'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _message = require('./message.css');

var _message2 = _interopRequireDefault(_message);

var _helper = require('../../shared/utils/helper');

var _helper2 = _interopRequireDefault(_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Message = function Message() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var messageComponent = null;
  return function () {
    if (!messageComponent) {
      messageComponent = new (Function.prototype.bind.apply(MessageComponent, [null].concat(args)))();
    }
    return messageComponent;
  }();
};

var MessageComponent = function () {
  function MessageComponent() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, MessageComponent);

    var _options$content = options.content,
        content = _options$content === undefined ? '' : _options$content,
        _options$className = options.className,
        className = _options$className === undefined ? '' : _options$className,
        _options$timeout = options.timeout,
        timeout = _options$timeout === undefined ? 2500 : _options$timeout,
        _options$showClose = options.showClose,
        showClose = _options$showClose === undefined ? true : _options$showClose,
        _options$isMobile = options.isMobile,
        isMobile = _options$isMobile === undefined ? false : _options$isMobile,
        _options$theme = options.theme,
        theme = _options$theme === undefined ? 'banner' : _options$theme,
        _options$type = options.type,
        type = _options$type === undefined ? 'positive' : _options$type;

    this.state = {
      type: type,
      theme: theme,
      content: content,
      timeout: timeout,
      isMobile: isMobile,
      showClose: showClose,
      className: className
    };
    this.timeout = null;
    this.$body = document.body;

    this.resetTemplate();
  }

  _createClass(MessageComponent, [{
    key: 'update',
    value: function update(options) {
      this._setState(options);
    }
  }, {
    key: '_setState',
    value: function _setState(newState) {
      this.timeout && clearTimeout(this.timeout);
      this.timeout = null;
      Object.assign(this.state, newState);
      this.resetTemplate();
    }
  }, {
    key: 'error',
    value: function error(msg, timeout) {
      this.$message.classList.remove(_message2.default.positive);
      this.$message.classList.remove(_message2.default.tips);
      this.$message.classList.add(_message2.default.negative);
      this.$message.childNodes[0].innerHTML = msg;

      this.showMessage(timeout);
    }
  }, {
    key: 'notice',
    value: function notice(msg, timeout) {
      this.$message.classList.remove(_message2.default.negative);
      this.$message.classList.remove(_message2.default.tips);
      this.$message.classList.add(_message2.default.positive);
      this.$message.childNodes[0].innerHTML = msg;

      this.showMessage(timeout);
    }
  }, {
    key: 'tips',
    value: function tips(msg, timeout) {
      this.$message.classList.remove(_message2.default.negative);
      this.$message.classList.remove(_message2.default.positive);
      this.$message.classList.add(_message2.default.tips);
      this.$message.childNodes[0].innerHTML = msg;

      this.showMessage(timeout);
    }
  }, {
    key: 'showMessage',
    value: function showMessage() {
      var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state.timeout;

      this.$message.classList.add(_message2.default.active);
      this.autoHideMessage(timeout);
    }
  }, {
    key: 'autoHideMessage',
    value: function autoHideMessage(timeout) {
      var _this = this;

      var hideMessage = function hideMessage() {
        _this.$message.classList.remove(_message2.default.active);
      };
      this.timeout = setTimeout(hideMessage, timeout);
    }
  }, {
    key: 'appendMessage',
    value: function appendMessage() {
      var _this2 = this;

      this.$body.appendChild(this.$message);
      var closeIcon = this.$message.childNodes[1];
      if (!closeIcon) return;

      var closeFunc = function closeFunc() {
        _this2.$message.classList.remove(_message2.default.active);
      };
      if (closeIcon.addEventListener) {
        closeIcon.addEventListener('click', closeFunc.bind(this), true);
      } else {
        closeIcon.attachEvent('onmousedown', closeFunc.bind(this));
      }
    }
  }, {
    key: 'messageTemplate',
    value: function messageTemplate() {
      var _state = this.state,
          className = _state.className,
          type = _state.type,
          content = _state.content,
          theme = _state.theme,
          isMobile = _state.isMobile,
          showClose = _state.showClose;

      var id = _helper2.default.uuid();
      var message = document.createElement('div');
      message.className = (0, _classnames2.default)(_message2.default.messageComponent, _message2.default[type], _message2.default[theme], isMobile && _message2.default.mobileMessage, className);

      message.innerHTML = '<div id="' + id + '" class="' + _message2.default.messageContent + '">' + content + '</div>' + (!showClose ? '' : '<i class="fa fa-close" aria-hidden="true"></i>');
      this.state.id = id;
      return message;
    }
  }, {
    key: 'resetTemplate',
    value: function resetTemplate() {
      this.$message && this.$message.remove();
      this.$message = this.messageTemplate();
      this.appendMessage();
    }
  }]);

  return MessageComponent;
}();

exports.default = Message;