'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _message = require('./message.css');

var _message2 = _interopRequireDefault(_message);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ShortMessage = function ShortMessage() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var messageComponent = null;
  return function () {
    if (!messageComponent) {
      messageComponent = new (Function.prototype.bind.apply(MessageComponent, [null].concat(args)))();
    }
    return messageComponent;
  }();
};

var MessageComponent = function () {
  function MessageComponent() {
    var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 2500;
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, MessageComponent);

    this.state = {
      timeout: timeout,
      style: options.style || {},
      className: options.className || ''
    };
    this.$message = null;
    this.$body = document.body;
  }

  _createClass(MessageComponent, [{
    key: 'update',
    value: function update(newState) {
      Object.assign(this.state, newState);
    }
  }, {
    key: 'show',
    value: function show(msg) {
      var time = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.state.timeout;

      this.$message = this._messageTemplate(msg);
      this.$body.appendChild(this.$message);
      this._autoHide(time);
    }
  }, {
    key: '_hide',
    value: function _hide() {
      try {
        this.$body.removeChild(this.$message);
      } catch (err) {}
      this.$message = null;
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.$message && this._hide();
    }
  }, {
    key: '_autoHide',
    value: function _autoHide(time) {
      var _this = this;

      var hideMessage = function hideMessage() {
        return _this._hide();
      };
      setTimeout(hideMessage, time);
    }
  }, {
    key: '_messageTemplate',
    value: function _messageTemplate(msg) {
      var _this2 = this;

      var message = document.createElement('div');
      message.className = (0, _classnames2.default)(_message2.default.messageComponent, this.state.className);
      Object.keys(this.state.style).forEach(function (key) {
        message.style[key] = _this2.state.style[key];
      });
      message.innerHTML = msg;
      return message;
    }
  }]);

  return MessageComponent;
}();

exports.default = ShortMessage;