'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _button = require('./button.css');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseButton = function (_React$Component) {
  _inherits(BaseButton, _React$Component);

  function BaseButton(props) {
    _classCallCheck(this, BaseButton);

    var _this = _possibleConstructorReturn(this, (BaseButton.__proto__ || Object.getPrototypeOf(BaseButton)).call(this, props));

    _this.state = {
      pressed: false
    };
    _this.onClick = _this.onClick.bind(_this);
    _this.onMouseDown = _this.onMouseDown.bind(_this);
    _this.onMouseUp = _this.onMouseUp.bind(_this);
    _this.onMouseEnter = _this.onMouseEnter.bind(_this);
    _this.onMouseLeave = _this.onMouseLeave.bind(_this);
    return _this;
  }

  _createClass(BaseButton, [{
    key: 'onClick',
    value: function onClick() {
      var onClick = this.props.onClick;

      onClick && onClick();
    }
  }, {
    key: 'onMouseDown',
    value: function onMouseDown() {
      this.setState({ pressed: true });
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp() {
      this.setState({ pressed: false });
    }
  }, {
    key: 'onMouseEnter',
    value: function onMouseEnter() {
      var onMouseEnter = this.props.onMouseEnter;

      onMouseEnter && onMouseEnter();
    }
  }, {
    key: 'onMouseLeave',
    value: function onMouseLeave() {
      this.onMouseUp();
      var onMouseLeave = this.props.onMouseLeave;

      onMouseLeave && onMouseLeave();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          id = _props.id,
          type = _props.type,
          theme = _props.theme,
          color = _props.color,
          style = _props.style,
          active = _props.active,
          disabled = _props.disabled,
          children = _props.children,
          clickable = _props.clickable,
          className = _props.className,
          onTransitionEnd = _props.onTransitionEnd;
      var pressed = this.state.pressed;


      var buttonClass = (0, _classnames2.default)(_button2.default.button, _button2.default[type], _button2.default[theme], _button2.default[color], !disabled && clickable && _button2.default.clickable, !disabled && pressed && _button2.default.pressDown, active && _button2.default.active, disabled && _button2.default.disabled, className);
      var onClick = disabled ? Function.prototype : this.onClick;

      return _react2.default.createElement(
        'div',
        {
          id: id,
          style: style,
          onClick: onClick,
          className: buttonClass,
          onMouseUp: this.onMouseUp,
          onMouseOut: this.onMouseUp,
          onMouseDown: this.onMouseDown,
          onMouseLeave: this.onMouseLeave,
          onMouseEnter: this.onMouseEnter,
          onTransitionEnd: onTransitionEnd
        },
        _react2.default.createElement(
          'div',
          { className: _button2.default.wrapper },
          children
        )
      );
    }
  }]);

  return BaseButton;
}(_react2.default.Component);

BaseButton.propTypes = {
  id: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  onTransitionEnd: _propTypes2.default.func,
  color: _propTypes2.default.string,
  className: _propTypes2.default.string,
  style: _propTypes2.default.object,
  theme: _propTypes2.default.string,
  type: _propTypes2.default.string,
  active: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.node, _propTypes2.default.array, _propTypes2.default.string]),
  clickable: _propTypes2.default.bool
};

BaseButton.defaultProps = {
  id: '',
  color: 'green',
  theme: 'material',
  type: 'button',
  onClick: Function.prototype,
  className: '',
  style: {},
  active: false,
  disabled: false,
  children: _react2.default.createElement('div', null),
  clickable: true
};

exports.default = BaseButton;