'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _BaseButton = require('../BaseButton');

var _BaseButton2 = _interopRequireDefault(_BaseButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = function Button(props) {
  var value = props.value,
      leftIcon = props.leftIcon,
      rightIcon = props.rightIcon;

  var baseProps = Object.assign({}, props);

  var leftIconElement = typeof leftIcon === 'string' ? _react2.default.createElement('i', { className: 'fa fa-' + leftIcon, 'aria-hidden': 'true' }) : leftIcon;

  var rightIconElement = typeof rightIcon === 'string' ? _react2.default.createElement('i', { className: 'fa fa-' + rightIcon, 'aria-hidden': 'true' }) : rightIcon;

  delete baseProps.leftIcon;
  delete baseProps.rightIcon;
  delete baseProps.value;

  return _react2.default.createElement(
    _BaseButton2.default,
    baseProps,
    _react2.default.createElement(
      'div',
      null,
      leftIconElement,
      _react2.default.createElement(
        'span',
        null,
        value
      ),
      rightIconElement
    )
  );
};

Button.propTypes = {
  value: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  color: _propTypes2.default.string,
  style: _propTypes2.default.object,
  className: _propTypes2.default.string,
  theme: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  leftIcon: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.string, _propTypes2.default.array]),
  rightIcon: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.string, _propTypes2.default.array])
};

Button.defaultProps = {
  value: '',
  color: 'green',
  style: {},
  theme: 'material',
  onClick: Function.prototype,
  leftIcon: null,
  rightIcon: null,
  className: '',
  disabled: false
};

exports.default = Button;