'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _group = require('./group.css');

var _group2 = _interopRequireDefault(_group);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonGroup = function (_React$Component) {
  _inherits(ButtonGroup, _React$Component);

  function ButtonGroup() {
    _classCallCheck(this, ButtonGroup);

    return _possibleConstructorReturn(this, (ButtonGroup.__proto__ || Object.getPrototypeOf(ButtonGroup)).apply(this, arguments));
  }

  _createClass(ButtonGroup, [{
    key: 'renderButtons',
    value: function renderButtons() {
      var _props = this.props,
          color = _props.color,
          disabled = _props.disabled,
          children = _props.children;

      if (!Array.isArray(children)) return children;

      var doms = [];

      for (var i = 0; i < children.length; i += 1) {
        var child = children[i];
        if (i > 0) {
          doms.push(_react2.default.createElement('div', { className: _group2.default.divider }));
        }
        if (i > 0 && child.props.active) doms.pop();
        if (i > 0 && children[i - 1].props.active) doms.pop();
        doms.push((0, _react.cloneElement)(child, {
          key: i,
          className: (0, _classnames2.default)(child.props.className, _group2.default.button, child.props.active && _group2.default.active),
          disabled: disabled || child.props.disabled,
          color: color || child.props.color
        }));
      }
      return doms;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          color = _props2.color,
          theme = _props2.theme,
          disabled = _props2.disabled,
          className = _props2.className;

      var containerClass = (0, _classnames2.default)(_group2.default.container, theme && _group2.default[theme], color && _group2.default[color], disabled && _group2.default.disabled, className);
      return _react2.default.createElement(
        'div',
        { className: containerClass },
        this.renderButtons()
      );
    }
  }]);

  return ButtonGroup;
}(_react2.default.Component);

ButtonGroup.propTypes = {
  buttons: _propTypes2.default.array,
  className: _propTypes2.default.string,
  theme: _propTypes2.default.string,
  color: _propTypes2.default.string,
  disabled: _propTypes2.default.bool
};

ButtonGroup.defaultProps = {
  color: 'blue',
  buttons: [],
  className: '',
  theme: 'material',
  disabled: false
};

exports.default = ButtonGroup;