'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _button = require('./button.css');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ClassicButton = function (_React$PureComponent) {
  _inherits(ClassicButton, _React$PureComponent);

  function ClassicButton(props) {
    _classCallCheck(this, ClassicButton);

    var _this = _possibleConstructorReturn(this, (ClassicButton.__proto__ || Object.getPrototypeOf(ClassicButton)).call(this, props));

    _this.state = {
      pressed: false
    };

    _this.onMouseDown = _this.onMouseDown.bind(_this);
    _this.onMouseUp = _this.onMouseUp.bind(_this);
    _this.onMouseEnter = _this.onMouseEnter.bind(_this);
    _this.onMouseLeave = _this.onMouseLeave.bind(_this);
    return _this;
  }

  _createClass(ClassicButton, [{
    key: 'onMouseDown',
    value: function onMouseDown() {
      this.setState({ pressed: true });
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp() {
      this.setState({ pressed: false });
    }
  }, {
    key: 'onMouseEnter',
    value: function onMouseEnter() {
      var onMouseEnter = this.props.onMouseEnter;

      onMouseEnter && onMouseEnter();
    }
  }, {
    key: 'onMouseLeave',
    value: function onMouseLeave() {
      this.onMouseUp();
      var onMouseLeave = this.props.onMouseLeave;

      onMouseLeave && onMouseLeave();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          theme = _props.theme,
          disabled = _props.disabled,
          content = _props.content,
          children = _props.children,
          className = _props.className,
          onTransitionEnd = _props.onTransitionEnd,
          buttonWrapperClassName = _props.buttonWrapperClassName,
          buttonContainerClassName = _props.buttonContainerClassName;
      var pressed = this.state.pressed;

      var onClick = disabled ? Function.prototype : this.props.onClick;

      return _react2.default.createElement(
        'div',
        {
          onClick: onClick || Function.prototype,
          className: (0, _classnames2.default)(_button2.default.buttonContainer, buttonContainerClassName)
        },
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)(_button2.default.buttonWrapper, _button2.default['wrapper_' + theme], disabled && _button2.default.disabled, !disabled && pressed && _button2.default.pressDown, buttonWrapperClassName),
            onMouseUp: this.onMouseUp,
            onMouseOut: this.onMouseUp,
            onMouseDown: this.onMouseDown,
            onMouseLeave: this.onMouseLeave,
            onMouseEnter: this.onMouseEnter,
            onTransitionEnd: onTransitionEnd
          },
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_button2.default.buttonContent, className) },
            children || content
          )
        )
      );
    }
  }]);

  return ClassicButton;
}(_react2.default.PureComponent);

exports.default = ClassicButton;