'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _fab = require('./fab.css');

var _fab2 = _interopRequireDefault(_fab);

var _BaseButton = require('../BaseButton');

var _BaseButton2 = _interopRequireDefault(_BaseButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FloatingActionButton = function FloatingActionButton(props) {
  var icon = props.icon,
      style = props.style,
      className = props.className;

  var baseProps = Object.assign({}, props);

  var iconElement = typeof icon === 'string' ? _react2.default.createElement('i', { className: 'fa fa-' + icon, 'aria-hidden': 'true' }) : icon;

  delete baseProps.style;
  delete baseProps.icon;

  return _react2.default.createElement(
    _BaseButton2.default,
    _extends({}, baseProps, {
      style: _extends({}, style, {
        width: '50px',
        height: '50px'
      }),
      className: (0, _classnames2.default)(className, _fab2.default.fab),
      type: 'floating-action-button'
    }),
    iconElement
  );
};

FloatingActionButton.propTypes = {
  style: _propTypes2.default.object,
  onClick: _propTypes2.default.func,
  className: _propTypes2.default.string,
  icon: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.string, _propTypes2.default.array])
};

FloatingActionButton.defaultProps = {
  style: {},
  onClick: Function.prototype,
  className: '',
  icon: ''
};

exports.default = FloatingActionButton;