'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _BaseButton = require('../BaseButton');

var _BaseButton2 = _interopRequireDefault(_BaseButton);

var _button = require('./button.css');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var IconButton = function IconButton(props) {
  var icon = props.icon,
      className = props.className;

  var baseProps = Object.assign({}, props);

  var iconElement = typeof icon === 'string' ? _react2.default.createElement('i', { className: 'fa fa-' + icon, 'aria-hidden': 'true' }) : icon;

  delete baseProps.className;
  delete baseProps.icon;

  return _react2.default.createElement(
    _BaseButton2.default,
    _extends({}, baseProps, {
      className: (0, _classnames2.default)(_button2.default.iconButton, className)
    }),
    iconElement
  );
};

IconButton.propTypes = {
  icon: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.string, _propTypes2.default.array]),
  className: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  disabled: _propTypes2.default.bool,
  theme: _propTypes2.default.string
};

IconButton.defaultProps = {
  icon: '',
  onClick: Function.prototype,
  className: '',
  disabled: false,
  theme: 'ghost'
};

exports.default = IconButton;