'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _group = require('./group.css');

var _group2 = _interopRequireDefault(_group);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CardGroup = function CardGroup(props) {
  var style = props.style,
      theme = props.theme,
      children = props.children,
      className = props.className,
      onTransitionEnd = props.onTransitionEnd;


  var hasCardGroup = false;

  var cards = Array.isArray(children) ? children.map(function (child, index) {
    var isCardGroup = child.type.prototype === CardGroup.prototype;
    if (isCardGroup) hasCardGroup = true;

    var childProps = isCardGroup ? {
      key: index,
      className: _group2.default.cardsChild
    } : {
      key: index,
      theme: 'ghost',
      className: _group2.default.card
    };
    return (0, _react.cloneElement)(child, childProps);
  }) : (0, _react.cloneElement)(children, {
    theme: 'ghost',
    className: _group2.default.card
  });

  var groupClass = (0, _classnames2.default)(_group2.default.cardsContainer, hasCardGroup && _group2.default.cardsContainerWrapper, theme && hasCardGroup && _group2.default[theme], className);

  return _react2.default.createElement(
    'div',
    {
      style: style,
      className: groupClass,
      onTransitionEnd: onTransitionEnd
    },
    cards
  );
};

CardGroup.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.node, _propTypes2.default.array]),
  className: _propTypes2.default.string,
  theme: _propTypes2.default.string,
  style: _propTypes2.default.object,
  onTransitionEnd: _propTypes2.default.func
};

CardGroup.defaultProps = {
  children: _react2.default.createElement('div', null),
  className: '',
  theme: null,
  style: {}
};

exports.default = CardGroup;