'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _card = require('./card.css');

var _card2 = _interopRequireDefault(_card);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ClassicCard = function ClassicCard(props) {
  var flat = props.flat,
      style = props.style,
      onClick = props.onClick,
      clickable = props.clickable,
      hoverable = props.hoverable,
      children = props.children,
      className = props.className,
      bgClassName = props.bgClassName;


  return _react2.default.createElement(
    'div',
    {
      style: style,
      className: (0, _classnames2.default)(_card2.default.infoCard, _card2.default.classic, flat && _card2.default.flat, hoverable && _card2.default.hoverable, className, (onClick !== null || clickable) && _card2.default.clickable),
      onClick: onClick || Function.prototype
    },
    _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)(_card2.default.bg, bgClassName) },
      children
    )
  );
};

ClassicCard.propTypes = {
  flat: _propTypes2.default.bool,
  clickable: _propTypes2.default.bool,
  hoverable: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  bgClassName: _propTypes2.default.string,
  style: _propTypes2.default.object,
  onClick: _propTypes2.default.func
};

ClassicCard.defaultProps = {
  flat: false,
  clickable: false,
  hoverable: true,
  className: '',
  bgClassName: '',
  style: {},
  onClick: null
};

exports.default = ClassicCard;