'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Tipso = require('../../Tipso/Tipso');

var _Tipso2 = _interopRequireDefault(_Tipso);

var _card = require('./card.css');

var _card2 = _interopRequireDefault(_card);

var _icons = require('../../../shared/utils/icons');

var _icons2 = _interopRequireDefault(_icons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var InfoCard = function InfoCard(props) {
  var icon = props.icon,
      tipso = props.tipso,
      theme = props.theme,
      style = props.style,
      subText = props.subText,
      mainText = props.mainText,
      onClick = props.onClick,
      children = props.children,
      className = props.className,
      cardClassName = props.cardClassName,
      tipsoTheme = props.tipsoTheme,
      subTextStyle = props.subTextStyle,
      tipsoTrigger = props.tipsoTrigger,
      mainTextStyle = props.mainTextStyle;


  if (children) {
    return _react2.default.createElement(
      'div',
      {
        style: style,
        className: (0, _classnames2.default)(_card2.default.infoCard, theme && _card2.default[theme], className, cardClassName, onClick !== null && _card2.default.clickable),
        onClick: onClick || Function.prototype
      },
      children
    );
  }

  var iconElement = typeof icon === 'string' ? _react2.default.createElement('i', { className: 'fa fa-' + icon, 'aria-hidden': 'true' }) : icon;
  var tipsoIcon = tipso && _typeof(tipso.icon) === 'object' ? tipso.icon : _icons2.default.info;

  var tipsoDOM = null;
  if (tipso !== null) {
    if (!tipso.text && !tipso.icon) {
      tipsoDOM = tipso;
    } else {
      tipsoDOM = _react2.default.createElement(
        _Tipso2.default,
        {
          theme: tipsoTheme,
          trigger: tipsoTrigger,
          tipsoStyle: tipso.style || {},
          className: _card2.default.infoTipso,
          wrapperClass: _card2.default.infoTipsoWrapper,
          tipsoContent: _react2.default.createElement(
            'span',
            null,
            tipso.text
          ) },
        tipsoIcon
      );
    }
  }

  return _react2.default.createElement(
    'div',
    {
      style: style,
      className: (0, _classnames2.default)(_card2.default.infoCard, theme && _card2.default[theme], tipso && _card2.default.withTipso, className, cardClassName, onClick !== null && _card2.default.clickable),
      onClick: onClick || Function.prototype
    },
    tipsoDOM,
    _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)(_card2.default.infoMainText, mainTextStyle) },
      icon ? iconElement : null,
      mainText
    ),
    typeof subText === 'string' ? _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)(_card2.default.infoSubText, subTextStyle) },
      subText
    ) : subText
  );
};

InfoCard.propTypes = {
  mainText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.node, _propTypes2.default.element]),
  subText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.node, _propTypes2.default.element]),
  mainTextStyle: _propTypes2.default.string,
  subTextStyle: _propTypes2.default.string,
  className: _propTypes2.default.string,
  cardClassName: _propTypes2.default.string,
  icon: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.string]),
  tipso: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.object]),
  tipsoTrigger: _propTypes2.default.string,
  style: _propTypes2.default.object,
  theme: _propTypes2.default.string,
  tipsoTheme: _propTypes2.default.string,
  onClick: _propTypes2.default.func
};

InfoCard.defaultProps = {
  mainText: '',
  subText: '',
  mainTextStyle: '',
  subTextStyle: '',
  className: '',
  cardClassName: '',
  icon: null,
  tipso: null,
  tipsoTrigger: 'hover',
  style: {},
  theme: 'material',
  tipsoTheme: 'light',
  onClick: null
};

exports.default = InfoCard;