'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _dropdown = require('./dropdown.css');

var _dropdown2 = _interopRequireDefault(_dropdown);

var _OutsideClickHandler = require('../../shared/components/OutsideClickHandler');

var _OutsideClickHandler2 = _interopRequireDefault(_OutsideClickHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_React$PureComponent) {
  _inherits(Dropdown, _React$PureComponent);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

    _this.state = {
      active: false
    };

    _this.onMenuClick = _this.onMenuClick.bind(_this);
    _this.onOutsideClick = _this.onOutsideClick.bind(_this);
    _this.onActiveChange = _this.onActiveChange.bind(_this);
    _this.onActiveToggle = _this.onActiveToggle.bind(_this);
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'onMenuClick',
    value: function onMenuClick(callback) {
      var _this2 = this;

      var closeOnClick = this.props.closeOnClick;

      return function () {
        callback && callback();
        closeOnClick && _this2.onOutsideClick();
      };
    }
  }, {
    key: 'onOutsideClick',
    value: function onOutsideClick() {
      var closeOnOutsideClick = this.props.closeOnOutsideClick;

      closeOnOutsideClick && this.onActiveChange(false);
    }
  }, {
    key: 'onActiveChange',
    value: function onActiveChange(active) {
      this.setState({ active: active });
      if (!active) {
        var onDropdownClose = this.props.onDropdownClose;

        onDropdownClose && onDropdownClose();
      }
    }
  }, {
    key: 'onActiveToggle',
    value: function onActiveToggle() {
      var active = this.state.active;

      this.onActiveChange(!active);
    }
  }, {
    key: 'renderMainArea',
    value: function renderMainArea() {
      var _this3 = this;

      var _props = this.props,
          disabled = _props.disabled,
          button = _props.button;

      var onClick = disabled ? Function.prototype : function () {
        return _this3.onActiveToggle();
      };

      return (0, _react.cloneElement)(button, {
        onClick: onClick
      });
    }
  }, {
    key: 'renderMenuPanel',
    value: function renderMenuPanel() {
      var _this4 = this;

      var _props2 = this.props,
          content = _props2.content,
          showPanelTriangle = _props2.showPanelTriangle,
          menuPanelClassName = _props2.menuPanelClassName;
      var active = this.state.active;


      var dom = content;
      if (Array.isArray(content)) {
        dom = content.map(function (item, index) {
          var _item$props = item.props,
              onClick = _item$props.onClick,
              className = _item$props.className;

          return (0, _react.cloneElement)(item, {
            key: 'menu-' + index,
            className: (0, _classnames2.default)(_dropdown2.default.menu, className),
            onClick: _this4.onMenuClick(onClick)
          });
        });
      }

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)(_dropdown2.default.menusContainer, showPanelTriangle && _dropdown2.default.useTriangle, menuPanelClassName, active && _dropdown2.default.menusContainerActived)
        },
        dom
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var className = this.props.className;


      return _react2.default.createElement(
        _OutsideClickHandler2.default,
        {
          onOutsideClick: this.onOutsideClick,
          className: (0, _classnames2.default)(_dropdown2.default.dropdownContainer, className)
        },
        this.renderMainArea(),
        this.renderMenuPanel()
      );
    }
  }]);

  return Dropdown;
}(_react2.default.PureComponent);

Dropdown.propTypes = {
  className: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  showPanelTriangle: _propTypes2.default.bool,
  closeOnClick: _propTypes2.default.bool,
  closeOnOutsideClick: _propTypes2.default.bool,
  content: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.array, _propTypes2.default.element, _propTypes2.default.string]),
  button: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.array]),
  menuPanelClassName: _propTypes2.default.string,
  onDropdownClose: _propTypes2.default.func
};

Dropdown.defaultProps = {
  className: '',
  disabled: false,
  content: [],
  showPanelTriangle: true,
  closeOnClick: true,
  closeOnOutsideClick: true,
  button: _react2.default.createElement('div', null),
  menuPanelClassName: '',
  onDropdownClose: Function.prototype
};

exports.default = Dropdown;