'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _input = require('./input.css');

var _input2 = _interopRequireDefault(_input);

var _validator = require('../../../shared/utils/validator');

var _validator2 = _interopRequireDefault(_validator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_React$Component) {
  _inherits(Input, _React$Component);

  function Input(props) {
    _classCallCheck(this, Input);

    var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

    _this.state = {
      error: false
    };

    _this.onChange = _this.onChange.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    _this.onKeyUp = _this.onKeyUp.bind(_this);
    _this.onKeyDown = _this.onKeyDown.bind(_this);
    _this.onFocus = _this.onFocus.bind(_this);
    return _this;
  }

  _createClass(Input, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var autoFocus = this.props.autoFocus;

      autoFocus && this.input.focus();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(preProps) {
      var value = this.props.value;

      if (value && !preProps.value) {
        this.check(value);
      }
    }
  }, {
    key: 'onChange',
    value: function onChange() {
      var value = this.input.value;
      var onChange = this.props.onChange;

      onChange && onChange(value);
      var error = this.state.error;

      if (error) {
        this.check();
      }
    }
  }, {
    key: 'onBlur',
    value: function onBlur(e) {
      this.check();
      var value = this.input.value;
      var onBlur = this.props.onBlur;

      onBlur && onBlur(value);
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(e) {
      var onKeyDown = this.props.onKeyDown;

      onKeyDown && onKeyDown(e);
    }
  }, {
    key: 'onKeyUp',
    value: function onKeyUp(e) {
      this.check();
      var onKeyUp = this.props.onKeyUp;

      onKeyUp && onKeyUp(e);
    }
  }, {
    key: 'onFocus',
    value: function onFocus(e) {
      var onFocus = this.props.onFocus;

      onFocus && onFocus(e);
    }
  }, {
    key: 'check',
    value: function check(inputValue) {
      var _props = this.props,
          type = _props.type,
          onCheck = _props.onCheck,
          required = _props.required,
          validator = _props.validator,
          validateOptions = _props.validateOptions;

      if (!required) return;

      var value = inputValue || this.input.value;
      try {
        var error = validator ? !validator(value) : !_validator2.default[type](value, validateOptions);
        this.setState({ error: error });
        onCheck && onCheck(error);
      } catch (e) {
        console.error(e);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          id = _props2.id,
          type = _props2.type,
          theme = _props2.theme,
          style = _props2.style,
          value = _props2.value,
          subTheme = _props2.subTheme,
          required = _props2.required,
          disabled = _props2.disabled,
          className = _props2.className,
          placeholder = _props2.placeholder;
      var error = this.state.error;

      var inputClass = (0, _classnames2.default)(_input2.default.input, _input2.default[theme], _input2.default[subTheme], required && error && _input2.default.error, disabled && _input2.default.disabled, className);

      return _react2.default.createElement('input', {
        id: id,
        type: type,
        value: value,
        style: style,
        required: required,
        disabled: disabled,
        onBlur: this.onBlur,
        onKeyUp: this.onKeyUp,
        onFocus: this.onFocus,
        className: inputClass,
        onChange: this.onChange,
        placeholder: placeholder,
        onKeyDown: this.onKeyDown,
        ref: function ref(_ref) {
          return _this2.input = _ref;
        }
      });
    }
  }]);

  return Input;
}(_react2.default.Component);

Input.propTypes = {
  disabled: _propTypes2.default.bool,
  required: _propTypes2.default.bool,
  autoFocus: _propTypes2.default.bool,
  value: _propTypes2.default.string,
  style: _propTypes2.default.object,
  validateOptions: _propTypes2.default.object,
  className: _propTypes2.default.string,
  id: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  type: _propTypes2.default.string,
  theme: _propTypes2.default.string,
  subTheme: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  onKeyUp: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onKeyDown: _propTypes2.default.func,
  validator: _propTypes2.default.func
};

Input.defaultProps = {
  required: true,
  disabled: false,
  autoFocus: false,
  value: '',
  style: {},
  validateOptions: {},
  validator: null,
  className: '',
  id: '',
  placeholder: '',
  type: 'string',
  theme: 'material',
  subTheme: '',
  onChange: Function.prototype,
  onBlur: Function.prototype,
  onKeyUp: Function.prototype,
  onFocus: Function.prototype,
  onKeyDown: Function.prototype
};

exports.default = Input;