'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Tipso = require('../../Tipso/Tipso');

var _Tipso2 = _interopRequireDefault(_Tipso);

var _group = require('./group.css');

var _group2 = _interopRequireDefault(_group);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputGroup = function (_React$Component) {
  _inherits(InputGroup, _React$Component);

  function InputGroup() {
    _classCallCheck(this, InputGroup);

    return _possibleConstructorReturn(this, (InputGroup.__proto__ || Object.getPrototypeOf(InputGroup)).apply(this, arguments));
  }

  _createClass(InputGroup, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          tipsoStyle = _props.tipsoStyle,
          tipsoTheme = _props.tipsoTheme,
          onTipClose = _props.onTipClose,
          wrapperStyle = _props.wrapperStyle,
          tipsoPosition = _props.tipsoPosition,
          tipsoClassName = _props.tipsoClassName,
          inputClassName = _props.inputClassName,
          wrapperClassName = _props.wrapperClassName;


      return _react2.default.createElement(
        _Tipso2.default,
        {
          trigger: 'focus',
          wrapperStyle: _extends({}, wrapperStyle, {
            margin: '0 5px'
          }),
          theme: tipsoTheme,
          tipsoContent: children,
          onTipClose: onTipClose,
          position: tipsoPosition,
          className: tipsoClassName,
          tipsoStyle: _extends({}, tipsoStyle),
          wrapperClass: wrapperClassName
        },
        _react2.default.createElement(_Input2.default, _extends({}, this.props, {
          className: (0, _classnames2.default)(_group2.default.input, inputClassName)
        }))
      );
    }
  }]);

  return InputGroup;
}(_react2.default.Component);

InputGroup.propTypes = {
  tipsoTheme: _propTypes2.default.string,
  tipsoPosition: _propTypes2.default.string,
  inputClassName: _propTypes2.default.string,
  tipsoClassName: _propTypes2.default.string,
  wrapperClassName: _propTypes2.default.string,
  wrapperStyle: _propTypes2.default.object,
  tipsoStyle: _propTypes2.default.object,
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.string, _propTypes2.default.array])
};

InputGroup.defaultProps = {
  tipsoTheme: 'light',
  tipsoPosition: 'top',
  inputClassName: '',
  tipsoClassName: '',
  wrapperClassName: '',
  wrapperStyle: {},
  tipsoStyle: {},
  children: _react2.default.createElement('div', null)
};

exports.default = InputGroup;