'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _group = require('./group.css');

var _group2 = _interopRequireDefault(_group);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputGroupV2 = function (_React$Component) {
  _inherits(InputGroupV2, _React$Component);

  function InputGroupV2(props) {
    _classCallCheck(this, InputGroupV2);

    var _this = _possibleConstructorReturn(this, (InputGroupV2.__proto__ || Object.getPrototypeOf(InputGroupV2)).call(this, props));

    _this.state = {
      error: false,
      focus: false
    };

    _this.onBlur = _this.onBlur.bind(_this);
    _this.onFocus = _this.onFocus.bind(_this);
    _this.onCheck = _this.onCheck.bind(_this);
    return _this;
  }

  _createClass(InputGroupV2, [{
    key: 'onCheck',
    value: function onCheck(error) {
      this.setState({ error: error });
    }
  }, {
    key: 'onFocus',
    value: function onFocus() {
      this.setState({ focus: true });
    }
  }, {
    key: 'onBlur',
    value: function onBlur() {
      this.setState({ focus: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          theme = _props.theme,
          style = _props.style,
          sections = _props.sections,
          className = _props.className;
      var _state = this.state,
          error = _state.error,
          focus = _state.focus;


      var inputs = sections.map(function (section, index) {
        return _react2.default.createElement(_Input2.default, _extends({
          key: index
        }, section, {
          theme: 'ghost',
          className: (0, _classnames2.default)(_group2.default.input, section.className),
          onBlur: _this2.onBlur,
          onFocus: _this2.onFocus,
          onCheck: _this2.onCheck
        }));
      });

      return _react2.default.createElement(
        'div',
        {
          style: style,
          className: (0, _classnames2.default)(_group2.default.group, _group2.default[theme], focus && _group2.default.focus, error && _group2.default.error, className)
        },
        inputs
      );
    }
  }]);

  return InputGroupV2;
}(_react2.default.Component);

InputGroupV2.defaultProps = {
  style: {},
  sections: [],
  className: '',
  theme: 'material'
};

exports.default = InputGroupV2;