'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _selector = require('./selector.css');

var _selector2 = _interopRequireDefault(_selector);

var _icons = require('../../../shared/utils/icons');

var _icons2 = _interopRequireDefault(_icons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Selector = function (_React$Component) {
  _inherits(Selector, _React$Component);

  function Selector(props) {
    _classCallCheck(this, Selector);

    var _this = _possibleConstructorReturn(this, (Selector.__proto__ || Object.getPrototypeOf(Selector)).call(this, props));

    _this.onChange = _this.onChange.bind(_this);
    return _this;
  }

  _createClass(Selector, [{
    key: 'onChange',
    value: function onChange() {
      var value = this.selector.value;
      var onChange = this.props.onChange;

      onChange && onChange(value);
    }
  }, {
    key: 'renderOptions',
    value: function renderOptions() {
      var options = this.props.options;

      return options.map(function (option, index) {
        var id = option.id,
            value = option.value;

        return _react2.default.createElement(
          'option',
          { key: index, value: id },
          value
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          value = _props.value,
          theme = _props.theme,
          className = _props.className,
          disabled = _props.disabled;

      var containerClass = (0, _classnames2.default)(_selector2.default.selectorContainer, _selector2.default[theme], disabled && _selector2.default.selectorDisabled, className);
      var onChange = disabled ? Function.prototype : this.onChange;
      return _react2.default.createElement(
        'div',
        { className: containerClass },
        this.currentValue,
        '\xA0\xA0\xA0',
        _icons2.default.down,
        _react2.default.createElement(
          'select',
          {
            value: value,
            onChange: onChange,
            className: _selector2.default.selector,
            ref: function ref(_ref) {
              return _this2.selector = _ref;
            } },
          this.renderOptions()
        )
      );
    }
  }, {
    key: 'currentValue',
    get: function get() {
      var _props2 = this.props,
          value = _props2.value,
          options = _props2.options;

      var filtered = options.filter(function (option) {
        return option.id === value;
      });
      if (!filtered.length) {
        return options[0].value;
      }
      return filtered[0].value;
    }
  }]);

  return Selector;
}(_react2.default.Component);

Selector.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  theme: _propTypes2.default.string,
  className: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  options: _propTypes2.default.array,
  disabled: _propTypes2.default.bool
};

Selector.defaultProps = {
  value: '',
  theme: 'material',
  options: [],
  onChange: Function.prototype,
  className: '',
  disabled: false
};

exports.default = Selector;