'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Option = require('./Option');

var _Option2 = _interopRequireDefault(_Option);

var _selector = require('./selector.css');

var _selector2 = _interopRequireDefault(_selector);

var _icons = require('../../../shared/utils/icons');

var _icons2 = _interopRequireDefault(_icons);

var _helper = require('../../../shared/utils/helper');

var _helper2 = _interopRequireDefault(_helper);

var _OutsideClickHandler = require('../../../shared/components/OutsideClickHandler');

var _OutsideClickHandler2 = _interopRequireDefault(_OutsideClickHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SelectorV2 = function (_React$Component) {
  _inherits(SelectorV2, _React$Component);

  function SelectorV2(props) {
    _classCallCheck(this, SelectorV2);

    var _this = _possibleConstructorReturn(this, (SelectorV2.__proto__ || Object.getPrototypeOf(SelectorV2)).call(this, props));

    _this.state = {
      active: false
    };
    _this.onChange = _this.onChange.bind(_this);
    _this.handleOutsideClick = _this.handleOutsideClick.bind(_this);
    _this.handleActiveChange = _this.handleActiveChange.bind(_this);
    _this.handleActiveToggle = _this.handleActiveToggle.bind(_this);
    return _this;
  }

  _createClass(SelectorV2, [{
    key: 'onChange',
    value: function onChange(val) {
      var onChange = this.props.onChange;

      onChange && onChange(val);
      this.handleOutsideClick();
    }
  }, {
    key: 'handleOutsideClick',
    value: function handleOutsideClick() {
      this.handleActiveChange(false);
      var onSelectorClose = this.props.onSelectorClose;

      onSelectorClose && onSelectorClose();
    }
  }, {
    key: 'handleActiveChange',
    value: function handleActiveChange(active) {
      this.setState({ active: active });
    }
  }, {
    key: 'handleActiveToggle',
    value: function handleActiveToggle() {
      var active = this.state.active;

      this.handleActiveChange(!active);
    }
  }, {
    key: 'renderOptions',
    value: function renderOptions() {
      var _this2 = this;

      var _props = this.props,
          value = _props.value,
          options = _props.options,
          optionClassName = _props.optionClassName,
          optionModalClassName = _props.optionModalClassName;

      var optionComponents = options.map(function (option, index) {
        var id = option.id,
            hidden = option.hidden;

        if (hidden) return null;
        return _react2.default.createElement(_Option2.default, {
          id: id,
          key: index,
          value: option.value,
          onClick: _this2.onChange,
          disabled: option.disabled,
          isActive: id === value,
          className: optionClassName
        });
      });

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)(_selector2.default.optionsContainer, optionModalClassName),
          style: { minWidth: this.selectorWidth + 'px' }
        },
        optionComponents
      );
    }
  }, {
    key: 'renderSelected',
    value: function renderSelected() {
      var _props2 = this.props,
          value = _props2.value,
          options = _props2.options,
          flexable = _props2.flexable,
          selectedClassName = _props2.selectedClassName;


      var targetOptions = options.filter(function (option) {
        return option.id === value;
      });
      var targetValue = targetOptions[0] && targetOptions[0].value || '';

      if (!flexable) {
        var maxLengthValue = this.maxLengthValue;
        return _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(_selector2.default.valueWrapper, selectedClassName) },
          _react2.default.createElement(
            'span',
            { className: _selector2.default.value },
            targetValue
          ),
          _react2.default.createElement(
            'span',
            { className: _selector2.default.valueHidden },
            maxLengthValue
          )
        );
      }

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)(_selector2.default.valueWrapper, selectedClassName) },
        targetValue
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var active = this.state.active;
      var _props3 = this.props,
          theme = _props3.theme,
          color = _props3.color,
          disabled = _props3.disabled,
          showArrow = _props3.showArrow,
          className = _props3.className;


      var containerClass = (0, _classnames2.default)(_selector2.default.selectorContainer, _selector2.default['selector-' + color], _selector2.default[theme], active && _selector2.default.selectorContainerActive, disabled && _selector2.default.selectorDisabled, className);

      var onClick = disabled ? Function.prototype : function () {
        return _this3.handleActiveToggle();
      };

      return _react2.default.createElement(
        'div',
        { className: containerClass },
        _react2.default.createElement(
          _OutsideClickHandler2.default,
          { onOutsideClick: this.handleOutsideClick },
          _react2.default.createElement(
            'div',
            { className: _selector2.default.wrapper, onClick: onClick },
            this.renderSelected(),
            showArrow && _react2.default.createElement(
              'span',
              null,
              '\xA0\xA0\xA0',
              _react2.default.createElement(
                'span',
                { className: _selector2.default.icon },
                _icons2.default.down
              )
            )
          ),
          this.renderOptions()
        )
      );
    }
  }, {
    key: 'maxLengthValue',
    get: function get() {
      var options = this.props.options;

      var maxValue = options[0] && options[0].text || '';
      options.forEach(function (option) {
        if (_helper2.default.getStringWidth(option.value) > _helper2.default.getStringWidth(maxValue)) {
          maxValue = option.value;
        }
      });
      return maxValue;
    }
  }, {
    key: 'selectorWidth',
    get: function get() {
      var optionClassName = this.props.optionClassName;

      var tmpClassName = (0, _classnames2.default)(_selector2.default.option, optionClassName, _selector2.default.optionHidden);
      var maxLengthValue = this.maxLengthValue;

      var tmpNode = document.createElement('div');
      tmpNode.setAttribute('class', tmpClassName);
      var hiddenDOM = document.createElement('div');
      hiddenDOM.setAttribute('class', (0, _classnames2.default)(_selector2.default.optionWrapper, _selector2.default.optionHiddenItem));
      hiddenDOM.appendChild(document.createTextNode(maxLengthValue));
      tmpNode.appendChild(hiddenDOM);

      document.body.appendChild(tmpNode);
      var width = hiddenDOM.offsetWidth + 40;
      tmpNode.remove();
      return width;
    }
  }]);

  return SelectorV2;
}(_react2.default.Component);

SelectorV2.propTypes = {
  options: _propTypes2.default.array,
  value: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string, _propTypes2.default.number]),
  onChange: _propTypes2.default.func,
  onSelectorClose: _propTypes2.default.func,
  theme: _propTypes2.default.string,
  color: _propTypes2.default.string,
  className: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  showArrow: _propTypes2.default.bool,
  flexable: _propTypes2.default.bool,
  optionClassName: _propTypes2.default.string,
  selectedClassName: _propTypes2.default.string,
  optionModalClassName: _propTypes2.default.string
};

SelectorV2.defaultProps = {
  options: [],
  onChange: Function.prototype,
  onSelectorClose: Function.prototype,
  theme: 'material',
  color: 'green',
  className: '',
  disabled: false,
  showArrow: true,
  flexable: false,
  optionClassName: '',
  selectedClassName: '',
  optionModalClassName: ''
};

exports.default = SelectorV2;