'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _textarea = require('./textarea.css');

var _textarea2 = _interopRequireDefault(_textarea);

var _validator = require('../../../shared/utils/validator');

var _validator2 = _interopRequireDefault(_validator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var countWords = function countWords(val) {
  return val.length;
};

var Textarea = function (_React$Component) {
  _inherits(Textarea, _React$Component);

  function Textarea(props) {
    _classCallCheck(this, Textarea);

    var _this = _possibleConstructorReturn(this, (Textarea.__proto__ || Object.getPrototypeOf(Textarea)).call(this, props));

    _this.state = {
      error: false,
      focus: false
    };
    _this.onChange = _this.onChange.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    _this.onFocus = _this.onFocus.bind(_this);
    _this.onKeyDown = _this.onKeyDown.bind(_this);
    return _this;
  }

  _createClass(Textarea, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(preProps) {
      var value = this.props.value;

      if (value && !preProps.value) {
        this.check(value);
      }
    }
  }, {
    key: 'onChange',
    value: function onChange() {
      var value = this.textarea.value;
      var onChange = this.props.onChange;

      onChange && onChange(value);
      var error = this.state.error;

      if (error) {
        this.check();
      }
    }
  }, {
    key: 'onFocus',
    value: function onFocus(e) {
      this.setState({ focus: true });
    }
  }, {
    key: 'onBlur',
    value: function onBlur(e) {
      this.check();
      this.setState({ focus: false });
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(e) {
      var onKeyDown = this.props.onKeyDown;

      onKeyDown(e);
    }
  }, {
    key: 'check',
    value: function check(inputValue) {
      var value = inputValue || this.textarea.value;
      var _props = this.props,
          minLength = _props.minLength,
          maxLength = _props.maxLength,
          validator = _props.validator;

      var error = validator ? !validator(value) : !_validator2.default.textarea(value, {
        min: parseInt(minLength, 10),
        max: parseInt(maxLength, 10)
      });
      this.setState({ error: error });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          value = _props2.value,
          disabled = _props2.disabled,
          className = _props2.className,
          placeholder = _props2.placeholder,
          wordCountTemplate = _props2.wordCountTemplate;
      var _state = this.state,
          focus = _state.focus,
          error = _state.error;


      var wrapperClass = (0, _classnames2.default)(_textarea2.default.textareaWrapper, _textarea2.default.flat, focus && _textarea2.default.focus, error && _textarea2.default.error, disabled && _textarea2.default.disabled, className);

      var wordCount = this.props.wordCount || countWords;

      return _react2.default.createElement(
        'div',
        { className: wrapperClass },
        _react2.default.createElement(
          'pre',
          { className: _textarea2.default.textareaHidden },
          _react2.default.createElement(
            'span',
            null,
            value
          ),
          _react2.default.createElement('br', null)
        ),
        _react2.default.createElement('textarea', {
          value: value,
          disabled: disabled,
          placeholder: placeholder,
          onChange: this.onChange,
          ref: function ref(_ref) {
            return _this2.textarea = _ref;
          },
          className: _textarea2.default.textarea,
          onKeyDown: this.onKeyDown,
          onBlur: this.onBlur,
          onFocus: this.onFocus
        }),
        wordCountTemplate && _react2.default.createElement(
          'div',
          { className: _textarea2.default.textareaTip },
          wordCountTemplate.replace('%n', wordCount(value))
        )
      );
    }
  }]);

  return Textarea;
}(_react2.default.Component);

Textarea.propTypes = {
  value: _propTypes2.default.string,
  className: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  wordCount: _propTypes2.default.func,
  onKeyDown: _propTypes2.default.func,
  disabled: _propTypes2.default.bool,
  minLength: _propTypes2.default.number,
  maxLength: _propTypes2.default.number,
  placeholder: _propTypes2.default.string,
  validator: _propTypes2.default.func,
  wordCountTemplate: _propTypes2.default.string
};

Textarea.defaultProps = {
  value: '',
  className: '',
  placeholder: '',
  onChange: Function.prototype,
  onKeyDown: Function.prototype,
  disabled: false,
  minLength: 0,
  maxLength: 999,
  wordCount: null,
  validator: null,
  wordCountTemplate: '已输入%n字'
};

exports.default = Textarea;