'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _loading = require('./loading.css');

var _loading2 = _interopRequireDefault(_loading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Loading = function (_React$Component) {
  _inherits(Loading, _React$Component);

  function Loading(props) {
    _classCallCheck(this, Loading);

    var _this = _possibleConstructorReturn(this, (Loading.__proto__ || Object.getPrototypeOf(Loading)).call(this, props));

    _this.state = {
      loading: props.loading
    };
    _this.onClose = _this.onClose.bind(_this);
    return _this;
  }

  _createClass(Loading, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var loading = nextProps.loading;

      if (loading !== this.state.loading) {
        this.setState({ loading: loading });
      }
    }
  }, {
    key: 'onClose',
    value: function onClose() {
      var _props = this.props,
          onClose = _props.onClose,
          closeAble = _props.closeAble;

      if (!closeAble) return;
      this.setState({ loading: false });
      onClose && onClose();
    }
  }, {
    key: 'render',
    value: function render() {
      var loading = this.state.loading;
      var _props2 = this.props,
          theme = _props2.theme,
          style = _props2.style,
          className = _props2.className,
          color = _props2.color,
          loaderColor = _props2.loaderColor;

      var containerClass = (0, _classnames2.default)(_loading2.default.loadingContainer, _loading2.default[color], loading && _loading2.default.loadingActive, className);

      return _react2.default.createElement(
        'div',
        {
          style: style,
          onClick: this.onClose,
          className: containerClass
        },
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)(_loading2.default[theme + 'Wrapper'], _loading2.default[color])
          },
          _react2.default.createElement('div', { style: { backgroundColor: loaderColor } }),
          _react2.default.createElement('div', { style: { backgroundColor: loaderColor } })
        )
      );
    }
  }]);

  return Loading;
}(_react2.default.Component);

Loading.propTypes = {
  className: _propTypes2.default.string,
  theme: _propTypes2.default.string,
  loading: _propTypes2.default.bool,
  closeAble: _propTypes2.default.bool,
  onClose: _propTypes2.default.func,
  style: _propTypes2.default.object,
  color: _propTypes2.default.string
};

Loading.defaultProps = {
  className: '',
  theme: 'rotate',
  loading: false,
  closeAble: false,
  onClose: null,
  style: {},
  color: 'dark'
};

exports.default = Loading;