'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactPortal = require('react-portal');

var _BaseModal = require('../BaseModal');

var _BaseModal2 = _interopRequireDefault(_BaseModal);

var _OutsideClickHandler = require('../../../shared/components/OutsideClickHandler');

var _OutsideClickHandler2 = _interopRequireDefault(_OutsideClickHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PortalModal = function PortalModal(props) {
  var onClose = props.onClose,
      children = props.children,
      showModal = props.showModal,
      closeOnEsc = props.closeOnEsc,
      closeOnOutsideClick = props.closeOnOutsideClick;

  return _react2.default.createElement(
    _OutsideClickHandler2.default,
    {
      targetKey: 27,
      onKeydown: onClose,
      onOutsideClick: onClose,
      responseKeydown: closeOnEsc,
      responseOutsideClick: closeOnOutsideClick
    },
    _react2.default.createElement(
      _reactPortal.Portal,
      null,
      _react2.default.createElement(
        _BaseModal2.default,
        { showModal: showModal, onClose: onClose },
        children
      )
    )
  );
};

PortalModal.propTypes = {
  closeOnEsc: _propTypes2.default.bool,
  showModal: _propTypes2.default.bool,
  closeOnOutsideClick: _propTypes2.default.bool,
  onClose: _propTypes2.default.func,
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.string, _propTypes2.default.array])
};

PortalModal.defaultProps = {
  closeOnEsc: true,
  showModal: false,
  closeOnOutsideClick: false,
  onClose: Function.prototype,
  children: _react2.default.createElement('div', null)
};

exports.default = PortalModal;