'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactPortal = require('react-portal');

var _BaseModal = require('../BaseModal');

var _BaseModal2 = _interopRequireDefault(_BaseModal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PortalModalWithState = function PortalModalWithState(props) {
  var onClose = props.onClose,
      children = props.children,
      showModal = props.showModal,
      closeOnEsc = props.closeOnEsc,
      defaultOpen = props.defaultOpen,
      closeOnOutsideClick = props.closeOnOutsideClick;

  return _react2.default.createElement(
    _reactPortal.PortalWithState,
    {
      closeOnEsc: closeOnEsc,
      onClose: onClose,
      defaultOpen: defaultOpen,
      closeOnOutsideClick: closeOnOutsideClick
    },
    function (_ref) {
      var openPortal = _ref.openPortal,
          closePortal = _ref.closePortal,
          isOpen = _ref.isOpen,
          portal = _ref.portal;

      if (showModal) {
        openPortal();
      } else {
        closePortal();
      }
      return portal(_react2.default.createElement(
        _BaseModal2.default,
        { showModal: true, onClose: onClose },
        children
      ));
    }
  );
};

PortalModalWithState.propTypes = {
  closeOnEsc: _propTypes2.default.bool,
  showModal: _propTypes2.default.bool,
  closeOnOutsideClick: _propTypes2.default.bool,
  onClose: _propTypes2.default.func,
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.element, _propTypes2.default.string, _propTypes2.default.array]),
  defaultOpen: _propTypes2.default.bool
};

PortalModalWithState.defaultProps = {
  closeOnEsc: true,
  showModal: false,
  closeOnOutsideClick: false,
  onClose: Function.prototype,
  children: _react2.default.createElement('div', null),
  defaultOpen: false
};

exports.default = PortalModalWithState;