'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _slider = require('./slider.css');

var _slider2 = _interopRequireDefault(_slider);

var _Tipso = require('../Tipso/Tipso');

var _Tipso2 = _interopRequireDefault(_Tipso);

var _darg = require('../../shared/utils/darg');

var _darg2 = _interopRequireDefault(_darg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dragger = function (_React$Component) {
  _inherits(Dragger, _React$Component);

  function Dragger(props) {
    _classCallCheck(this, Dragger);

    var _this = _possibleConstructorReturn(this, (Dragger.__proto__ || Object.getPrototypeOf(Dragger)).call(this, props));

    _this.state = {
      draging: false,
      showTipso: props.showTipso
    };

    _this.setLeft = _this.setLeft.bind(_this);
    _this.handleMouseDown = _this.handleMouseDown.bind(_this);
    _this.handleMouseMove = _this.handleMouseMove.bind(_this);
    _this.handleMouseUp = _this.handleMouseUp.bind(_this);
    return _this;
  }

  _createClass(Dragger, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (document.addEventListener) {
        document.addEventListener('mousemove', this.handleMouseMove, true);
        document.addEventListener('mouseup', this.handleMouseUp, true);
      } else {
        document.attachEvent('onmousemove', this.handleMouseMove);
        document.attachEvent('onmouseup', this.handleMouseUp);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (document.removeEventListener) {
        document.removeEventListener('mousemove', this.handleMouseMove, true);
        document.removeEventListener('mouseup', this.handleMouseUp, true);
      } else {
        document.detachEvent('onmousemove', this.handleMouseMove);
        document.detachEvent('onmouseup', this.handleMouseUp);
      }
    }
  }, {
    key: 'handleMouseMove',
    value: function handleMouseMove(e) {
      var event = e || window.event;
      if (this.state.draging) {
        var pos = _darg2.default.mousePosition(event);
        this.setLeft(pos);
      }
    }
  }, {
    key: 'handleMouseUp',
    value: function handleMouseUp(e) {
      var event = e || window.event;
      if (this.state.draging) {
        this.setState({
          draging: false,
          showTipso: false
        });
        var pos = _darg2.default.mousePosition(event);
        this.setLeft(pos, true);
      }
    }
  }, {
    key: 'handleMouseDown',
    value: function handleMouseDown(e) {
      var event = e || window.event;
      event.preventDefault();
      event.stopPropagation();
      this.setState({
        draging: true
      });
    }
  }, {
    key: 'setLeft',
    value: function setLeft(position) {
      var mouseUp = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var dragX = position.x;
      var _props = this.props,
          min = _props.min,
          max = _props.max,
          jump = _props.jump,
          maxDis = _props.maxDis,
          maxLeft = _props.maxLeft,
          minJump = _props.minJump,
          maxValue = _props.maxValue,
          minValue = _props.minValue,
          onDragEnd = _props.onDragEnd,
          onDraging = _props.onDraging;

      var leftLength = dragX - maxLeft;
      var offsetPercentage = leftLength / maxDis;

      var validateLeft = _darg2.default.getStandardAbsolutePosition(offsetPercentage, min, max);
      if (jump) {
        var val = validateLeft * (maxValue - minValue);
        var offset = val % minJump;
        val = offset > minJump / 2 ? val - offset + minJump : val - offset;
        validateLeft = val / (maxValue - minValue);
      }
      onDraging && onDraging(validateLeft);
      if (mouseUp) {
        onDragEnd && onDragEnd(validateLeft);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this,
          _React$createElement;

      var _props2 = this.props,
          left = _props2.left,
          color = _props2.color,
          value = _props2.value,
          useTipso = _props2.useTipso,
          showTipso = _props2.showTipso,
          tipsoClass = _props2.tipsoClass,
          tipsoTrigger = _props2.tipsoTrigger,
          tipFormatter = _props2.tipFormatter,
          draggerClass = _props2.draggerClass;


      var dragClass = (0, _classnames2.default)(_slider2.default.dragger, color && _slider2.default[color], draggerClass);
      var tipsoValue = tipFormatter ? tipFormatter(value) : value;
      return _react2.default.createElement(
        _Tipso2.default,
        (_React$createElement = {
          theme: 'dark',
          show: showTipso,
          disabled: !useTipso,
          trigger: tipsoTrigger
        }, _defineProperty(_React$createElement, 'show', this.state.draging), _defineProperty(_React$createElement, 'tipsoContent', _react2.default.createElement(
          'div',
          {
            style: {
              textAlign: 'center',
              minWidth: (tipsoValue.length + 1) * 5 + 'px'
            }
          },
          tipsoValue
        )), _defineProperty(_React$createElement, 'className', (0, _classnames2.default)(_slider2.default.tipso, tipsoClass)), _defineProperty(_React$createElement, 'wrapperClass', _slider2.default.draggerContainer), _defineProperty(_React$createElement, 'wrapperStyle', { left: left * 100 + '%' }), _React$createElement),
        _react2.default.createElement('div', {
          className: dragClass,
          ref: function ref(_ref) {
            return _this2.dragger = _ref;
          },
          onMouseDown: this.handleMouseDown
        })
      );
    }
  }]);

  return Dragger;
}(_react2.default.Component);

Dragger.propTypes = {
  color: _propTypes2.default.string,
  left: _propTypes2.default.number,
  value: _propTypes2.default.number,
  maxDis: _propTypes2.default.number,
  min: _propTypes2.default.number,
  max: _propTypes2.default.number,
  onDragEnd: _propTypes2.default.func,
  onDraging: _propTypes2.default.func,
  useTipso: _propTypes2.default.bool,
  showTipso: _propTypes2.default.bool,
  draggerClass: _propTypes2.default.string,
  tipsoClass: _propTypes2.default.string,
  tipsoTrigger: _propTypes2.default.string
};

Dragger.defaultProps = {
  left: 0,
  value: 0,
  maxDis: 0,
  min: 0,
  max: 0,
  color: 'green',
  onDragEnd: Function.prototype,
  onDraging: Function.prototype,
  useTipso: true,
  showTipso: false,
  draggerClass: '',
  tipsoClass: '',
  tipsoTrigger: 'hover'
};

exports.default = Dragger;