'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _slider = require('./slider.css');

var _slider2 = _interopRequireDefault(_slider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ProgressBar = function ProgressBar(props) {
  var left = props.left,
      right = props.right,
      color = props.color;

  var barClass = (0, _classnames2.default)(_slider2.default.progressBar, color && _slider2.default['bar-' + color]);
  return _react2.default.createElement('div', {
    className: barClass,
    style: {
      left: left * 100 + '%',
      right: right * 100 + '%'
    }
  });
};

ProgressBar.propTypes = {
  left: _propTypes2.default.number,
  right: _propTypes2.default.number,
  color: _propTypes2.default.string
};

ProgressBar.defaultProps = {
  left: 0,
  right: 0,
  color: 'green'
};

exports.default = ProgressBar;