'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Dragger = require('./Dragger');

var _Dragger2 = _interopRequireDefault(_Dragger);

var _slider = require('./slider.css');

var _slider2 = _interopRequireDefault(_slider);

var _ProgressBar = require('./ProgressBar');

var _ProgressBar2 = _interopRequireDefault(_ProgressBar);

var _helper = require('../../shared/utils/helper');

var _helper2 = _interopRequireDefault(_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Slider = function (_React$Component) {
  _inherits(Slider, _React$Component);

  function Slider(props) {
    _classCallCheck(this, Slider);

    var _this = _possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this, props));

    _this.state = Object.assign({}, _this.initialState(props), { maxDis: 0 });
    _this.onChange = _this.onChange.bind(_this);
    _this.onDraging = _this.onDraging.bind(_this);
    _this.onDragEnd = _this.onDragEnd.bind(_this);
    _this.onDragMove = _this.onDragMove.bind(_this);
    _this.changePosition = _this.changePosition.bind(_this);
    _this.resetOrigin = _this.resetOrigin.bind(_this);
    return _this;
  }

  _createClass(Slider, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.resetOrigin();
      if (window.addEventListener) {
        window.addEventListener('resize', this.resetOrigin, true);
      } else {
        window.addEventListener('onresize', this.resetOrigin);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (window.addEventListener) {
        window.removeEventListener('resize', this.resetOrigin, true);
      } else {
        window.detachEvent('onresize', this.resetOrigin);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var values = this.validateValues(nextProps);
      if (!_helper2.default.isEqual(values, this.state.values)) {
        this.setState(_extends({}, this.initialState(nextProps)));
      }
    }
  }, {
    key: 'validateValues',
    value: function validateValues(props) {
      var value = props.value;

      var values = Array.isArray(value) ? value : [value];
      return values;
    }
  }, {
    key: 'initialState',
    value: function initialState(props) {
      var max = props.max,
          min = props.min;

      var values = this.validateValues(props);
      var positions = values.map(function (item) {
        var left = (item - min) / (max - min);
        return { left: left };
      });
      return {
        values: values,
        positions: positions
      };
    }
  }, {
    key: 'resetOrigin',
    value: function resetOrigin() {
      var _this2 = this;

      var count = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;

      if (count >= 3) return;
      setTimeout(function () {
        if (!_this2.pathway) {
          _this2.resetOrigin(count);
        } else {
          var pathway = _reactDom2.default.findDOMNode(_this2.pathway).getBoundingClientRect();
          var maxDis = pathway.width;
          var maxLeft = pathway.left;
          _this2.setState({ maxDis: maxDis, maxLeft: maxLeft });
        }
      }, 100);
    }
  }, {
    key: 'onChange',
    value: function onChange() {
      var _this3 = this;

      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var index = options.index,
          left = options.left,
          _options$pos = options.pos,
          pos = _options$pos === undefined ? null : _options$pos;

      var positions = pos || this.state.positions;
      var onChange = this.props.onChange;

      var value = this.getValue(left);
      var returnValue = function returnValue(position) {
        return _this3.getValue(position.left);
      };
      var results = [].concat(_toConsumableArray(positions.slice(0, index).map(returnValue)), [value], _toConsumableArray(positions.slice(index + 1).map(returnValue)));
      if (!_helper2.default.checkSameArray(results, this.validateValues(this.props))) {
        var result = results.length > 1 ? results : results[0];
        onChange(result);
      }
    }
  }, {
    key: 'getValue',
    value: function getValue(left) {
      var _props = this.props,
          max = _props.max,
          min = _props.min;

      return Math.round(left * (max - min) + min);
    }
  }, {
    key: 'onDraging',
    value: function onDraging(index) {
      var _this4 = this;

      var updateWhenDrag = this.props.updateWhenDrag;

      return function (left) {
        var pos = _this4.changePosition(index, { left: left });
        if (updateWhenDrag) {
          _this4.onChange({
            pos: pos,
            left: left,
            index: index
          });
        }
      };
    }
  }, {
    key: 'onDragEnd',
    value: function onDragEnd(index) {
      var _this5 = this;

      return function (left) {
        var pos = _this5.changePosition(index, { left: left });
        _this5.onChange({
          index: index,
          left: left,
          pos: pos
        });
      };
    }
  }, {
    key: 'onDragMove',
    value: function onDragMove(leftPos) {
      var _this6 = this;

      return function () {
        var positions = _this6.state.positions;

        var leftOffsets = positions.map(function (position) {
          return Math.abs(position.left - leftPos);
        });
        var minLeftOffset = Math.min.apply(Math, _toConsumableArray(leftOffsets)).toFixed(2);
        var index = _helper2.default.findFirstIndex({
          array: positions,
          getVal: function getVal(position) {
            return position.left;
          },
          check: function check(val) {
            return Math.abs(val - leftPos).toFixed(2) === minLeftOffset;
          }
        });
        _this6.onDragEnd(index)(leftPos);
      };
    }
  }, {
    key: 'changePosition',
    value: function changePosition(index, position) {
      if (index <= -1) return null;
      var positions = this.state.positions;

      var newPos = [].concat(_toConsumableArray(positions.slice(0, index)), [Object.assign({}, positions[index], position)], _toConsumableArray(positions.slice(index + 1)));
      this.setState({
        positions: newPos
      });
      return newPos;
    }
  }, {
    key: 'renderDrager',
    value: function renderDrager() {
      var _this7 = this;

      var _state = this.state,
          positions = _state.positions,
          maxDis = _state.maxDis,
          maxLeft = _state.maxLeft;
      var _props2 = this.props,
          max = _props2.max,
          min = _props2.min,
          jump = _props2.jump,
          color = _props2.color,
          minJump = _props2.minJump,
          minRange = _props2.minRange,
          useTipso = _props2.useTipso,
          showTipso = _props2.showTipso,
          tipsoClass = _props2.tipsoClass,
          draggerClass = _props2.draggerClass,
          tipFormatter = _props2.tipFormatter;


      var minDis = minRange / (max - min);
      return positions.map(function (item, index) {
        var left = item.left;

        var value = _this7.getValue(left);
        var minPosition = index - 1 >= 0 ? positions[index - 1].left + minDis : 0;
        var maxPosition = index + 1 < positions.length ? positions[index + 1].left - minDis : 1;
        return _react2.default.createElement(_Dragger2.default, {
          jump: jump,
          key: index,
          left: left,
          color: color,
          value: value,
          maxValue: max,
          minValue: min,
          maxDis: maxDis,
          maxLeft: maxLeft,
          max: maxPosition,
          min: minPosition,
          minJump: minJump,
          useTipso: useTipso,
          showTipso: showTipso,
          tipsoClass: tipsoClass,
          tipFormatter: tipFormatter,
          draggerClass: draggerClass,
          onDragEnd: _this7.onDragEnd(index),
          onDraging: _this7.onDraging(index)
        });
      });
    }
  }, {
    key: 'renderProgressBar',
    value: function renderProgressBar() {
      var positions = this.state.positions;
      var color = this.props.color;

      var left = positions.length > 1 ? positions[0].left : 0;
      var right = 1 - positions.slice(-1)[0].left;
      return _react2.default.createElement(_ProgressBar2.default, {
        color: color,
        left: left,
        right: right
      });
    }
  }, {
    key: 'renderSections',
    value: function renderSections() {
      var _this8 = this;

      var _props3 = this.props,
          clickable = _props3.clickable,
          max = _props3.max,
          min = _props3.min,
          minJump = _props3.minJump,
          jump = _props3.jump;

      if (!clickable || !jump || minJump <= 0) return null;

      var positions = this.state.positions;

      var lefts = positions.map(function (position) {
        return position.left;
      });
      var maxLeft = Math.min.apply(Math, _toConsumableArray(lefts));
      var maxRight = Math.max.apply(Math, _toConsumableArray(lefts));
      if (positions.length === 1) maxLeft = 0;

      var length = (max - min) / minJump;
      return _helper2.default.createArray(length + 2).map(function (_, index) {
        var left = index / length;
        return _react2.default.createElement('div', {
          key: index,
          style: { left: left * 100 + '%' },
          className: (0, _classnames2.default)(_slider2.default.dragSection, left >= maxLeft && left <= maxRight && _slider2.default.light),
          onClick: _this8.onDragMove(left)
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this9 = this;

      var className = this.props.className;

      var containerClass = (0, _classnames2.default)(_slider2.default.container, className);
      return _react2.default.createElement(
        'div',
        { className: containerClass },
        _react2.default.createElement(
          'div',
          {
            className: _slider2.default.pathway,
            ref: function ref(_ref) {
              return _this9.pathway = _ref;
            }
          },
          this.renderSections(),
          this.renderDrager(),
          this.renderProgressBar()
        )
      );
    }
  }]);

  return Slider;
}(_react2.default.Component);

Slider.propTypes = {
  className: _propTypes2.default.string,
  tipFormatter: _propTypes2.default.func,
  min: _propTypes2.default.number,
  max: _propTypes2.default.number,
  value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.array]),
  minRange: _propTypes2.default.number,
  color: _propTypes2.default.string,
  draggerClass: _propTypes2.default.string,
  tipsoClass: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  useTipso: _propTypes2.default.bool,
  showTipso: _propTypes2.default.bool,
  jump: _propTypes2.default.bool,
  minJump: _propTypes2.default.number,
  clickable: _propTypes2.default.bool,
  updateWhenDrag: _propTypes2.default.bool
};

Slider.defaultProps = {
  className: '',
  tipFormatter: null,
  min: 0,
  max: 100,
  value: 10,
  minRange: 1,
  color: 'green',
  onChange: Function.prototype,
  useTipso: true,
  showTipso: false,
  draggerClass: '',
  tipsoClass: '',
  jump: false,
  minJump: 1,
  clickable: false,
  updateWhenDrag: false
};

exports.default = Slider;