'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _switcher = require('./switcher.css');

var _switcher2 = _interopRequireDefault(_switcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Switcher = function (_React$Component) {
  _inherits(Switcher, _React$Component);

  function Switcher(props) {
    _classCallCheck(this, Switcher);

    var _this = _possibleConstructorReturn(this, (Switcher.__proto__ || Object.getPrototypeOf(Switcher)).call(this, props));

    _this.state = {
      checked: props.checked
    };
    _this.onChange = _this.onChange.bind(_this);
    return _this;
  }

  _createClass(Switcher, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var checked = nextProps.checked;

      if (checked !== this.state.checked) {
        this.setState({ checked: checked });
      }
    }
  }, {
    key: 'onChange',
    value: function onChange() {
      var _props = this.props,
          onChange = _props.onChange,
          disabled = _props.disabled;

      if (disabled) return;

      var checked = this.state.checked;

      this.setState({ checked: !checked });
      onChange && onChange(!checked);
    }
  }, {
    key: 'render',
    value: function render() {
      var checked = this.state.checked;
      var _props2 = this.props,
          color = _props2.color,
          disabled = _props2.disabled,
          size = _props2.size,
          version = _props2.version,
          className = _props2.className;


      var containerClass = (0, _classnames2.default)(_switcher2.default.switcherContainer, version && _switcher2.default['switcher-' + version], size && _switcher2.default['container-' + size], checked && _switcher2.default.containerChecked, color && _switcher2.default[color], disabled && _switcher2.default.containerDisabled, className);

      return _react2.default.createElement(
        'div',
        {
          onClick: this.onChange,
          className: containerClass
        },
        _react2.default.createElement('div', { className: _switcher2.default.switcherItem })
      );
    }
  }]);

  return Switcher;
}(_react2.default.Component);

Switcher.propTypes = {
  color: _propTypes2.default.string,
  checked: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  onChange: _propTypes2.default.func,
  size: _propTypes2.default.string,
  version: _propTypes2.default.string,
  className: _propTypes2.default.string
};

Switcher.defaultProps = {
  color: 'green',
  checked: false,
  disabled: false,
  onChange: Function.prototype,
  size: 'normal',
  version: 'v1',
  className: ''
};

exports.default = Switcher;