'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _tipso = require('./tipso.css');

var _tipso2 = _interopRequireDefault(_tipso);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseTipso = function (_React$Component) {
  _inherits(BaseTipso, _React$Component);

  function BaseTipso(props) {
    _classCallCheck(this, BaseTipso);

    var _this = _possibleConstructorReturn(this, (BaseTipso.__proto__ || Object.getPrototypeOf(BaseTipso)).call(this, props));

    _this.state = {
      show: props.show
    };
    _this.handleShowChange = _this.handleShowChange.bind(_this);
    _this.onOutsideClick = _this.onOutsideClick.bind(_this);
    return _this;
  }

  _createClass(BaseTipso, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (document.addEventListener) {
        document.addEventListener('mousedown', this.onOutsideClick, true);
      } else {
        document.attachEvent('onmousedown', this.onOutsideClick);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (document.removeEventListener) {
        document.removeEventListener('mousedown', this.onOutsideClick, true);
      } else {
        document.detachEvent('onmousedown', this.onOutsideClick);
      }
    }
  }, {
    key: 'handleShowChange',
    value: function handleShowChange(show) {
      var _this2 = this;

      var onTipClose = this.props.onTipClose;

      return function () {
        _this2.setState({ show: show });
        !show && onTipClose && onTipClose();
      };
    }
  }, {
    key: 'onOutsideClick',
    value: function onOutsideClick(e) {
      e = e || window.event;
      var mouseTarget = typeof e.which !== 'undefined' ? e.which : e.button;
      var isDescendantOfRoot = _reactDom2.default.findDOMNode(this.tipso).contains(e.target);
      if (!isDescendantOfRoot && mouseTarget === 1) {
        this.handleShowChange(false)();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var show = this.state.show;
      var _props = this.props,
          theme = _props.theme,
          disabled = _props.disabled,
          position = _props.position,
          children = _props.children,
          className = _props.className,
          tipsoStyle = _props.tipsoStyle,
          wrapperClass = _props.wrapperClass,
          wrapperStyle = _props.wrapperStyle,
          tipsoContent = _props.tipsoContent,
          activeClassName = _props.activeClassName;

      var containerClass = (0, _classnames2.default)(_tipso2.default.tipsoContainer, _tipso2.default[theme], _tipso2.default[position], !disabled && (this.props.show || show) && _tipso2.default.active, !disabled && (this.props.show || show) && activeClassName, className);

      var triggerFunc = this.triggerFunc;
      var tipsoTrigger = (0, _react.cloneElement)(children, triggerFunc);

      return _react2.default.createElement(
        'div',
        {
          style: wrapperStyle,
          ref: function ref(_ref) {
            return _this3.tipso = _ref;
          },
          className: (0, _classnames2.default)(_tipso2.default.tipsoWrapper, wrapperClass)
        },
        tipsoTrigger,
        tipsoContent ? _react2.default.createElement(
          'div',
          {
            style: tipsoStyle,
            className: containerClass },
          _react2.default.createElement(
            'div',
            null,
            tipsoContent
          )
        ) : null
      );
    }
  }, {
    key: 'triggerFunc',
    get: function get() {
      var trigger = this.props.trigger;


      switch (trigger) {
        case 'hover':
          return {
            onMouseOver: this.handleShowChange(true).bind(this),
            onMouseEnter: this.handleShowChange(true).bind(this),
            onMouseOut: this.handleShowChange(false).bind(this),
            onMouseLeave: this.handleShowChange(false).bind(this)
          };
        case 'click':
          return {
            onClick: this.handleShowChange(true).bind(this)
          };
        case 'focus':
          return {
            onFocus: this.handleShowChange(true).bind(this)
          };
        default:
          return {};
      }
    }
  }]);

  return BaseTipso;
}(_react2.default.Component);

BaseTipso.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.node, _propTypes2.default.array, _propTypes2.default.string]),
  tipsoContent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.node, _propTypes2.default.array, _propTypes2.default.string]),
  className: _propTypes2.default.string,
  theme: _propTypes2.default.string,
  trigger: _propTypes2.default.string,
  tipsoStyle: _propTypes2.default.object,
  wrapperStyle: _propTypes2.default.object,
  wrapperClass: _propTypes2.default.string,
  position: _propTypes2.default.string,
  show: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  onTipClose: _propTypes2.default.func
};

BaseTipso.defaultProps = {
  children: _react2.default.createElement('div', null),
  tipsoContent: null,
  className: '',
  theme: 'light',
  trigger: 'hover',
  tipsoStyle: {},
  wrapperStyle: {},
  wrapperClass: '',
  position: 'top',
  show: false,
  disabled: false,
  onTipClose: Function.prototype
};

exports.default = BaseTipso;