'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helper = require('../utils/helper');

var _helper2 = _interopRequireDefault(_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var STATUS = {
  HIDDEN: 'hidden',
  ENTERED: 'entered',
  EXITING: 'exiting',
  ENTERING: 'entering'
};

var AnimationComponent = function (_React$Component) {
  _inherits(AnimationComponent, _React$Component);

  function AnimationComponent(props) {
    _classCallCheck(this, AnimationComponent);

    var _this = _possibleConstructorReturn(this, (AnimationComponent.__proto__ || Object.getPrototypeOf(AnimationComponent)).call(this, props));

    _this.state = {
      status: STATUS.HIDDEN
    };
    _this.onExit = _this.onExit.bind(_this);
    _this.onTransitionEnd = _this.onTransitionEnd.bind(_this);
    return _this;
  }

  _createClass(AnimationComponent, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      setTimeout(this.mountAnimation.bind(this), 10);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.exitingTimeout);
    }
  }, {
    key: 'onTransitionEnd',
    value: function onTransitionEnd() {
      this.setState({
        status: STATUS.ENTERED
      });
    }
  }, {
    key: 'onExit',
    value: function onExit(callback) {
      this.exitingTimeout = setTimeout(function () {
        return callback && callback();
      }, 100);
      this.unmountAnimation();
    }
  }, {
    key: 'unmountAnimation',
    value: function unmountAnimation() {
      this.setState({
        status: STATUS.EXITING
      });
    }
  }, {
    key: 'mountAnimation',
    value: function mountAnimation() {
      this.setState({
        status: STATUS.ENTERING
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var status = this.state.status;
      var children = this.props.children;


      if (_helper2.default.isFunction(children)) {
        return children({
          status: status,
          onExit: this.onExit,
          onTransitionEnd: this.onTransitionEnd
        });
      }

      return (0, _react.cloneElement)(this.props.children, {
        status: status,
        onExit: this.onExit,
        onTransitionEnd: this.onTransitionEnd
      });
    }
  }]);

  return AnimationComponent;
}(_react2.default.Component);

exports.default = AnimationComponent;