'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  onKeydown: _propTypes2.default.func,
  targetKey: _propTypes2.default.number,
  onOutsideClick: _propTypes2.default.func,
  responseKeydown: _propTypes2.default.bool,
  responseOutsideClick: _propTypes2.default.bool
};

var defaultProps = {
  className: '',
  targetKey: null,
  children: _react2.default.createElement('span', null),
  onKeydown: Function.prototype,
  responseKeydown: false,
  onOutsideClick: Function.prototype,
  responseOutsideClick: true
};

var OutsideClickHandler = function (_React$Component) {
  _inherits(OutsideClickHandler, _React$Component);

  function OutsideClickHandler(props) {
    _classCallCheck(this, OutsideClickHandler);

    var _this = _possibleConstructorReturn(this, (OutsideClickHandler.__proto__ || Object.getPrototypeOf(OutsideClickHandler)).call(this, props));

    _this.onKeydown = _this.onKeydown.bind(_this);
    _this.onOutsideClick = _this.onOutsideClick.bind(_this);
    return _this;
  }

  _createClass(OutsideClickHandler, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          responseKeydown = _props.responseKeydown,
          responseOutsideClick = _props.responseOutsideClick;

      if (responseOutsideClick) {
        if (document.addEventListener) {
          document.addEventListener('mousedown', this.onOutsideClick, true);
        } else {
          document.attachEvent('onmousedown', this.onOutsideClick);
        }
      }
      if (responseKeydown) {
        if (document.addEventListener) {
          document.addEventListener('keydown', this.onKeydown, true);
        } else {
          document.attachEvent('keydown', this.onKeydown);
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _props2 = this.props,
          responseKeydown = _props2.responseKeydown,
          responseOutsideClick = _props2.responseOutsideClick;

      if (responseOutsideClick) {
        if (document.removeEventListener) {
          document.removeEventListener('mousedown', this.onOutsideClick, true);
        } else {
          document.detachEvent('onmousedown', this.onOutsideClick);
        }
      }
      if (responseKeydown) {
        if (document.removeEventListener) {
          document.removeEventListener('keydown', this.onKeydown, true);
        } else {
          document.detachEvent('keydown', this.onKeydown);
        }
      }
    }
  }, {
    key: 'onOutsideClick',
    value: function onOutsideClick(e) {
      e = e || window.event;
      var mouseTarget = typeof e.which !== "undefined" ? e.which : e.button;
      var isDescendantOfRoot = _reactDom2.default.findDOMNode(this.childNode).contains(e.target);
      if (!isDescendantOfRoot && mouseTarget === 1) {
        var onOutsideClick = this.props.onOutsideClick;

        onOutsideClick && onOutsideClick(e);
      }
    }
  }, {
    key: 'onKeydown',
    value: function onKeydown(e) {
      var _props3 = this.props,
          targetKey = _props3.targetKey,
          onKeydown = _props3.onKeydown;

      if (e.keyCode === targetKey) {
        onKeydown && onKeydown(e);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props4 = this.props,
          children = _props4.children,
          className = _props4.className;

      return _react2.default.createElement(
        'div',
        {
          className: className,
          ref: function ref(c) {
            return _this2.childNode = c;
          }
        },
        children
      );
    }
  }]);

  return OutsideClickHandler;
}(_react2.default.Component);

OutsideClickHandler.propTypes = propTypes;
OutsideClickHandler.defaultProps = defaultProps;

exports.default = OutsideClickHandler;