"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var mousePosition = function mousePosition(e) {
  e = e || window.event;
  var xPos = e.pageX ? e.pageX : e.clientX + document.body.scrollLeft - document.body.clientLeft;
  var yPos = e.pageY ? e.pageY : e.clientY + document.body.scrollTop - document.body.clientTop;
  return {
    x: xPos,
    y: yPos
  };
};

var disableMouseDown = function disableMouseDown(e) {
  var event = e || window.event;
  event.preventDefault();
  event.stopPropagation();
};

var getStandardAbsolutePosition = function getStandardAbsolutePosition(position, minPosition, maxPosition) {
  return Math.min(maxPosition, Math.max(position, minPosition));
};

exports.default = {
  mousePosition: mousePosition,
  disableMouseDown: disableMouseDown,
  getStandardAbsolutePosition: getStandardAbsolutePosition
};