'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var isEqual = function isEqual(arrayA, arrayB) {
  for (var i = 0; i < arrayA.length; i += 1) {
    if (arrayA[i] !== arrayB[i]) {
      return false;
    }
  }
  return true;
};

var createArray = function createArray(length) {
  return new Array(length).join('0').split('');
};

var findFirstIndex = function findFirstIndex() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _options$array = options.array,
      array = _options$array === undefined ? [] : _options$array,
      _options$check = options.check,
      check = _options$check === undefined ? function (item) {
    return item;
  } : _options$check,
      _options$getVal = options.getVal,
      getVal = _options$getVal === undefined ? function (item) {
    return item;
  } : _options$getVal;


  var index = -1;
  for (var i = 0; i < array.length; i += 1) {
    var item = array[i];
    var val = getVal(item);
    if (check(val)) {
      index = i;
      break;
    }
  }
  return index;
};

var checkSameArray = function checkSameArray(arrayA, arrayB) {
  if (arrayA.length !== arrayB.length) return false;
  var same = true;

  var _loop = function _loop(i) {
    var item = arrayA[i];
    if (!arrayB.filter(function (i) {
      return i === item;
    }).length) {
      same = false;
      return 'break';
    }
  };

  for (var i = 0; i < arrayA.length; i += 1) {
    var _ret = _loop(i);

    if (_ret === 'break') break;
  }
  return same;
};

var s4 = function s4() {
  return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
};

var uuid = function uuid() {
  return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
};

var getType = {};
var isFunction = function isFunction(func) {
  return func && getType.toString.call(func) === '[object Function]';
};

var strLength = function strLength(str) {
  return str ? str.length : 0;
};

var getStringWidth = function getStringWidth(str) {
  var cnChars = str.match(/[\u4e00-\u9fa5【】「」“”；：，。‘’（）！？]/g);
  var enChars = str.match(/[a-zA-Z]/g);
  var smallChars = '';
  try {
    smallChars = str.match(/[_\-.|/,^$!?@#%&*()[]\{\}`~:;'"]/g);
  } catch (e) {
    console.error(e);
  }
  var numChars = str.match(/[0-9]/g);
  var others = str.length - strLength(cnChars) - strLength(enChars) - strLength(smallChars) - strLength(numChars);
  return strLength(cnChars) * 1.5 + strLength(enChars) + strLength(smallChars) * 0.8 + strLength(numChars) * 1.1 + others;
};

exports.default = {
  uuid: uuid,
  isEqual: isEqual,
  isFunction: isFunction,
  createArray: createArray,
  checkSameArray: checkSameArray,
  findFirstIndex: findFirstIndex,
  getStringWidth: getStringWidth
};