'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _validator = require('validator');

var _validator2 = _interopRequireDefault(_validator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var email = function email(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return _validator2.default.isEmail(value);
};

var phone = function phone(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return _validator2.default.isMobilePhone(value, options.local || 'zh-CN');
};

var empty = function empty(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return _validator2.default.isEmpty(value);
};

var number = function number(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return _validator2.default.isInt(value, {
    min: parseInt(options.min || 0, 10),
    max: parseInt(options.max || 99999, 10)
  });
};

var url = function url(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return _validator2.default.isURL(value);
};

var string = function string(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return _validator2.default.isByteLength(value, {
    min: parseInt(options.min || 1, 10),
    max: parseInt(options.max || 999, 10)
  });
};

var textarea = function textarea(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return _validator2.default.isByteLength(value, {
    min: options.min || 0,
    max: options.max || 999
  });
};

exports.default = {
  url: url,
  email: email,
  phone: phone,
  empty: empty,
  string: string,
  number: number,
  textarea: textarea
};